#include <stdio.h>
#define __USE_GNU
#include <pthread.h>
#include <string.h>

int main(int argc, char *argv[])
{
   int rc;
   pthread_mutex_t mutex = PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP;
   pthread_mutexattr_t mutexattr;

   system("cat mutex_errorcheck.c");

   printf("About to Lock\n");
   pthread_mutex_lock(&mutex);
   printf("Locked\n");
   pthread_mutex_unlock(&mutex);
   printf("Unlocked\n");

   printf("About to Lock\n");
   pthread_mutex_lock(&mutex);
   printf("Locked\n");
   printf("About to Lock a second time\n");

   if ((rc = pthread_mutex_lock(&mutex))) { printf("pthread_mutex_lock returned %d %s\n", rc, strerror(rc)); }
   else { printf("Locked Twice\n"); }

   if ((rc = pthread_mutex_unlock(&mutex))) { printf("pthread_mutex_unlock returned %d %s\n", rc, strerror(rc)); }
   else { printf("Unlocked Once\n"); }

   if ((rc = pthread_mutex_unlock(&mutex))) { printf("pthread_mutex_unlock returned %d %s\n", rc, strerror(rc)); }
   else { printf("Unlocked Twice\n"); }

   printf("Leaving, Bye\n");
}
