#include <pthread.h>
#include <stdio.h>

int main(int argc, char *argv[])
{
   system("cat mutex_recursive.c");
   pthread_mutex_t mutex;
   pthread_mutexattr_t mutexattr;

   pthread_mutexattr_init(&mutexattr);
   pthread_mutexattr_settype(&mutexattr, PTHREAD_MUTEX_RECURSIVE_NP);

   pthread_mutex_init(&mutex, &mutexattr);
   
   pthread_mutexattr_destroy(&mutexattr);

   printf("About to Lock\n");
   pthread_mutex_lock(&mutex);
   printf("Locked\n");
   pthread_mutex_unlock(&mutex);
   printf("Unlocked\n");

   printf("About to Lock\n");
   pthread_mutex_lock(&mutex);
   printf("Locked\n");
   printf("About to Lock a second time\n");
   pthread_mutex_lock(&mutex);
   printf("Locked Twice\n");
   pthread_mutex_unlock(&mutex);
   printf("Unlocked Once\n");
   pthread_mutex_unlock(&mutex);
   printf("Unlocked Twice\n");

   printf("Leaving, Bye\n");
}
