#include <stdio.h>
#include <pthread.h>
#include <unistd.h>


void *thread_worker(void *data) {
  int i = (int) data;
  usleep(((rand() % 1000) + 1) * 1000);
  printf ("Thread %d Worker\n", i);
}

const int NUM_THREADS = 5;

int main(int argc, char* argv[]) {
  int i;
  pthread_t thread[NUM_THREADS];
  void *threadrc[NUM_THREADS];

  srand(time(NULL));

  for (i=0; i < NUM_THREADS; i++) { 
    pthread_create(&thread[i], NULL, thread_worker, (void *) i);
  }

  for (i=0; i < NUM_THREADS; i++) { 
    pthread_join(thread[i], &threadrc[i]);
  }
}
